//
//  LDSParsingNotificationCodes.dart
//  DocumentReader
//
//  Created by Pavel Masiuk on 21.09.2023.
//  Copyright © 2023 Regula. All rights reserved.
//

part of document_reader;

enum LDSParsingNotificationCodes {
  /// Will be returned if [getByValue] if a non-existent was passed.
  UNKNOWN(-1),
  ASN_CERTIFICATE_INCORRECT_VERSION(0x90000001),
  ASN_CERTIFICATE_NON_MATCHING_SIGNATURE_ALGORITHM(0x90000002),
  ASN_CERTIFICATE_INCORRECT_TIME_CODING(0x90000003),
  ASN_CERTIFICATE_INCORRECT_USE_OF_GENERALIZED_TIME(0x90000004),
  ASN_CERTIFICATE_EMPTY_ISSUER(0x90000005),
  ASN_CERTIFICATE_EMPTY_SUBJECT(0x90000006),
  ASN_CERTIFICATE_UNSUPPORTED_CRITICAL_EXTENSION(0x90000008),
  ASN_CERTIFICATE_FORCED_DEFAULT_CSCA_ROLE(0x9000000E),
  ASN_CERTIFICATE_FORCED_DEFAULT_DS_ROLE(0x9000000F),
  ASN_CERTIFICATE_INCORRECT_ISSUER_SUBJECT_DS(0x90000010),
  ASN_CERTIFICATE_DUPLICATING_EXTENSIONS(0x90000017),
  ICAO_CERTIFICATE_VERSION_MISSED(0x90000200),
  ICAO_CERTIFICATE_VERSION_INCORRECT(0x90000201),
  ICAO_CERTIFICATE_ISSUER_COUNTRY_MISSED(0x90000202),
  ICAO_CERTIFICATE_ISSUER_COMMON_NAME_MISSED(0x90000203),
  ICAO_CERTIFICATE_ISSUER_COUNTRY_NON_COMPLIANT(0x90000204),
  ICAO_CERTIFICATE_SUBJECT_COUNTRY_MISSED(0x90000205),
  ICAO_CERTIFICATE_SUBJECT_COMMON_NAME_MISSED(0x90000206),
  ICAO_CERTIFICATE_SUBJECT_COUNTRY_NON_COMPLIANT(0x90000207),
  ICAO_CERTIFICATE_USING_NON_COMPLIANT_DATA(0x90000208),
  ICAO_CERTIFICATE_UNSUPPORTED_SIGNATURE_ALGORITHM(0x90000209),
  ICAO_CERTIFICATE_UNSUPPORTED_PUBLIC_KEY_ALGORITHM(0x9000020A),
  ICAO_CERTIFICATE_MISSED_EXTENSIONS(0x9000020B),
  ICAO_CERTIFICATE_VALIDITY(0x9000020C),
  ICAO_CERTIFICATE_EXT_USING_NON_COMPLIANT_DATA(0x9000020D),
  ICAO_CERTIFICATE_EXT_KEY_USAGE_MISSED(0x9000020E),
  ICAO_CERTIFICATE_EXT_KEY_USAGE_NOT_CRITICAL(0x9000020F),
  ICAO_CERTIFICATE_EXT_KEY_USAGE_INCORRECT_DATA(0x90000210),
  ICAO_CERTIFICATE_EXT_BASIC_C_MISSED(0x90000211),
  ICAO_CERTIFICATE_EXT_BASIC_C_INCORRECT_USAGE1(0x90000212),
  ICAO_CERTIFICATE_EXT_BASIC_C_INCORRECT_USAGE2(0x90000213),
  ICAO_CERTIFICATE_EXT_BASIC_C_NOT_CRITICAL(0x90000214),
  ICAO_CERTIFICATE_EXT_BASIC_C_INCORRECT_DATA(0x90000215),
  ICAO_CERTIFICATE_EXT_BASIC_C_PATH_LEN_C_MISSED(0x90000216),
  ICAO_CERTIFICATE_EXT_BASIC_C_PATH_LEN_C_INCORRECT(0x90000217),
  ICAO_CERTIFICATE_EXT_EXT_KEY_USAGE_NOT_CRITICAL(0x90000218),
  ICAO_CERTIFICATE_EXT_EXT_KEY_USAGE_INCORRECT_USAGE(0x90000219),
  ICAO_CERTIFICATE_EXT_EXT_KEY_USAGE_INCORRECT_DATA(0x9000021A),
  ICAO_CERTIFICATE_EXT_AUTH_KEY_ID_MISSED(0x9000021B),
  ICAO_CERTIFICATE_EXT_AUTH_KEY_ID_INCORRECT_DATA(0x9000021C),
  ICAO_CERTIFICATE_EXT_AUTH_KEY_ID_KEY_ID_MISSED(0x9000021D),
  ICAO_CERTIFICATE_EXT_SUBJECT_KEY_ID_MISSED(0x9000021E),
  ICAO_CERTIFICATE_EXT_SUBJECT_KEY_ID_INCORRECT_DATA(0x9000021F),
  ICAO_CERTIFICATE_EXT_PRIVATE_KEY_UP_MISSED(0x90000220),
  ICAO_CERTIFICATE_EXT_PRIVATE_KEY_UP_INCORRECT_DATA(0x90000221),
  ICAO_CERTIFICATE_EXT_PRIVATE_KEY_UP_EMPTY(0x90000222),
  ICAO_CERTIFICATE_EXT_SUBJECT_ALT_NAME_MISSED(0x90000223),
  ICAO_CERTIFICATE_EXT_SUBJECT_ALT_NAME_INCORRECT_DATA(0x90000224),
  ICAO_CERTIFICATE_EXT_SUBJECT_ALT_NAME_EMPTY(0x90000225),
  ICAO_CERTIFICATE_EXT_SUBJECT_ALT_NAME_NON_COMPLIANT(0x90000226),
  ICAO_CERTIFICATE_EXT_SUBJECT_ALT_NAME_CRITICAL(0x90000228),
  ICAO_CERTIFICATE_EXT_SUBJECT_ALT_NAME_DN_EMPTY(0x90000229),
  ICAO_CERTIFICATE_EXT_SUBJECT_ALT_NAME_DN_INCORRECT(0x9000022A),
  ICAO_CERTIFICATE_EXT_SUBJECT_ALT_NAME_DN_NON_COMPLIANT(0x9000022B),
  ICAO_CERTIFICATE_EXT_ISSUER_ALT_NAME_MISSED(0x9000022C),
  ICAO_CERTIFICATE_EXT_ISSUER_ALT_NAME_INCORRECT_DATA(0x9000022D),
  ICAO_CERTIFICATE_EXT_ISSUER_ALT_NAME_EMPTY(0x9000022E),
  ICAO_CERTIFICATE_EXT_ISSUER_ALT_NAME_NON_COMPLIANT(0x9000022F),
  ICAO_CERTIFICATE_EXT_ISSUER_ALT_NAME_CRITICAL(0x90000231),
  ICAO_CERTIFICATE_EXT_ISSUER_ALT_NAME_DN_EMPTY(0x90000232),
  ICAO_CERTIFICATE_EXT_ISSUER_ALT_NAME_DN_INCORRECT(0x90000233),
  ICAO_CERTIFICATE_EXT_ISSUER_ALT_NAME_DN_NON_COMPLIANT(0x90000234),
  ICAO_CERTIFICATE_EXT_DOC_TYPE_LIST_MISSED(0x90000235),
  ICAO_CERTIFICATE_EXT_DOC_TYPE_LIST_INCORRECT_DATA(0x90000236),
  ICAO_CERTIFICATE_EXT_DOC_TYPE_LIST_VERSION(0x90000237),
  ICAO_CERTIFICATE_EXT_DOC_TYPE_LIST_DOC_TYPES(0x90000238),
  ICAO_CERTIFICATE_EXT_DOC_TYPE_LIST_DOC_TYPES_EMPTY(0x90000239),
  ICAO_CERTIFICATE_EXT_CERT_POLICIES_INCORRECT_DATA(0x9000023A),
  ICAO_CERTIFICATE_EXT_CERT_POLICIES_EMPTY(0x9000023B),
  ICAO_CERTIFICATE_EXT_CERT_POLICIES_POLICY_ID_MISSED(0x9000023C),
  ICAO_CERTIFICATE_EXT_CRL_DIST_POINT_MISSED(0x9000023D),
  ICAO_CERTIFICATE_EXT_CRL_DIST_POINT_INCORRECT_DATA(0x9000023E),
  ICAO_CERTIFICATE_EXT_CRL_DIST_POINT_EMPTY(0x9000023F),
  ICAO_CERTIFICATE_EXT_CRL_DIST_POINT_POINT_MISSED(0x90000240),
  ICAO_CERTIFICATE_SN_NON_COMPLIANT(0x90000241),
  ICAO_CERTIFICATE_ISSUER_SN_NON_COMPLIANT(0x90000242),
  ICAO_CERTIFICATE_SUBJECT_SN_NON_COMPLIANT(0x90000243),
  ICAO_CERTIFICATE_ISSUER_ATTRIBUTE_NON_COMPLIANT(0x90000244),
  ICAO_CERTIFICATE_SUBJECT_ATTRIBUTE_NON_COMPLIANT(0x90000245),
  ICAO_CERTIFICATE_ISSUER_SUBJECT_COUNTRY_NON_MATCHING(0x90000246),
  ICAO_CERTIFICATE_EXT_CSCA_ALT_NAMES_NON_MATCHING(0x90000247),
  ICAO_CERTIFICATE_EXT_NAME_CHANGE_INCORRECT_DATA(0x90000248),
  ICAO_CERTIFICATE_EXT_NAME_CHANGE_NON_COMPLIANT(0x90000249),
  ICAO_CERTIFICATE_EXT_NAME_CHANGE_CRITICAL(0x9000024A),
  ICAO_CERTIFICATE_EXT_DOC_TYPE_LIST_NON_COMPLIANT(0x9000024B),
  ICAO_CERTIFICATE_EXT_DOC_TYPE_LIST_CRITICAL(0x9000024C),
  ICAO_CERTIFICATE_EXT_OPTIONAL_CRITICAL(0x9000024D),
  ICAO_CERTIFICATE_SUBJECT_NON_COMPLIANT(0x9000024E),
  ICAO_CERTIFICATE_SUBJECT_COMMON_NAME_NON_COMPLIANT(0x9000024F),
  ICAO_COM_LDS_VERSION_INCORRECT(0x90000020),
  ICAO_COM_LDS_VERSION_MISSING(0x90000021),
  ICAO_COM_UNICODE_VERSION_INCORRECT(0x90000022),
  ICAO_COM_UNICODE_VERSION_MISSING(0x90000023),
  ICAO_COM_DGPM_INCORRECT(0x90000024),
  ICAO_COM_DGPM_MISSING(0x90000025),
  ICAO_COM_DGPM_UNEXPECTED(0x90000026),
  ICAO_APPLICATION_LDS_VERSION_UNSUPPORTED(0x90000030),
  ICAO_APPLICATION_UNICODE_VERSION_UNSUPPORTED(0x90000031),
  ICAO_APPLICATION_LDS_VERSION_INCONSISTENT(0x90000032),
  ICAO_APPLICATION_UNICODE_VERSION_INCONSISTENT(0x90000033),
  ASN_SIGNED_DATA_OID_INCORRECT(0x90000100),
  ASN_SIGNED_DATA_VERSION_INCORRECT(0x900001A0),
  ASN_SIGNED_DATA_CONTENT_OID_INCORRECT(0x900001A1),
  ICAO_SIGNED_DATA_VERSION_INCORRECT(0x90000101),
  ICAO_SIGNED_DATA_DIGEST_ALGORITHMS_EMPTY(0x90000102),
  ICAO_SIGNED_DATA_DIGEST_ALGORITHMS_UNSUPPORTED(0x90000103),
  ICAO_SIGNED_DATA_SIGNER_INFOS_MULTIPLE_ENTRIES(0x90000109),
  ICAO_SIGNED_DATA_CERTIFICATES_MISSED(0x900001B0),
  ICAO_SIGNED_DATA_CERTIFICATES_EMPTY(0x900001B1),
  ICAO_SIGNED_DATA_CRLS_INCORRECT_USAGE(0x900001B2),
  ICAO_LDS_OBJECT_INCORRECT_CONTENT_OID(0x90000104),
  ICAO_LDS_OBJECT_DG_NUMBER_INCORRECT(0x90000105),
  ICAO_LDS_OBJECT_DG_HASH_MISSING(0x90000106),
  ICAO_LDS_OBJECT_DG_HASH_EXTRA(0x90000107),
  ICAO_LDS_OBJECT_VERSION_INCORRECT(0x90000108),
  ICAO_MASTER_LIST_VERSION_INCORRECT(0x900001C0),
  ICAO_DEVIATION_LIST_VERSION_INCORRECT(0x900001C8),
  BSI_DEFECT_LIST_VERSION_INCORRECT(0x900001D0),
  BSI_BLACK_LIST_VERSION_INCORRECT(0x900001D8),
  ASN_SIGNER_INFO_VERSION_INCORRECT(0x9000010A),
  ASN_SIGNER_INFO_SID_INCORRECT_CHOICE(0x9000010B),
  ASN_SIGNER_INFO_SID_DIGEST_ALGORITHM_NOT_LISTED(0x9000010C),
  ASN_SIGNER_INFO_MESSAGE_DIGEST_ATTR_MISSING(0x9000010D),
  ASN_SIGNER_INFO_MESSAGE_DIGEST_ATTR_DATA(0x9000010E),
  ASN_SIGNER_INFO_MESSAGE_DIGEST_ATTR_Value(0x9000010F),
  ASN_SIGNER_INFO_CONTENT_TYPE_ATTR_MISSING(0x90000110),
  ASN_SIGNER_INFO_CONTENT_TYPE_ATTR_DATA(0x90000111),
  ASN_SIGNER_INFO_CONTENT_TYPE_ATTR_VALUE(0x90000112),
  ASN_SIGNER_INFO_SIGNING_TIME_ATTR_MISSING(0x9000011B),
  ASN_SIGNER_INFO_SIGNING_TIME_ATTR_DATA(0x9000011C),
  ASN_SIGNER_INFO_SIGNING_TIME_ATTR_VALUE(0x9000011D),
  ASN_SIGNER_INFO_LIST_CONTENT_DESCRIPTION_ATTR_MISSING(0x9000011E),
  ASN_SIGNER_INFO_LIST_CONTENT_DESCRIPTION_ATTR_DATA(0x9000011F),
  AUTH_SIGNER_INFO_CERTIFICATE_VALIDITY(0x90000115),
  AUTH_SIGNER_INFO_CERTIFICATE_ROOT_IS_NOT_TRUSTED(0x90000116),
  AUTH_SIGNER_INFO_CERTIFICATE_CANT_FIND_CSCA(0x90000117),
  AUTH_SIGNER_INFO_CERTIFICATE_REVOKED(0x90000118),
  AUTH_SIGNER_INFO_CERTIFICATE_SIGNATURE_INVALID(0x90000119),
  UNSUPPORTED_IMAGE_FORMAT(0x9000011A),
  MRZ_DOCUMENT_TYPE_UNKNOWN(0x00022008),
  MRZ_ISSUING_STATE_SYNTAX_ERROR(0x00022009),
  MRZ_NAME_IS_VOID(0x0002200A),
  MRZ_NUMBER_INCORRECT_CHECKSUM(0x0002200D),
  MRZ_NATIONALITY_SYNTAX_ERROR(0x0002200E),
  MRZ_DOB_SYNTAX_ERROR(0x0002200F),
  MRZ_DOB_ERROR(0x00022010),
  MRZ_DOB_INCORRECT_CHECKSUM(0x00022011),
  MRZ_SEX_INCORRECT(0x00022012),
  MRZ_DOE_SYNTAX_ERROR(0x00022013),
  MRZ_DOE_ERROR(0x00022014),
  MRZ_DOE_INCORRECT_CHECKSUM(0x00022015),
  MRZ_OPTIONAL_DATA_INCORRECT_CHECKSUM(0x00022016),
  MRZ_INCORRECT_CHECKSUM(0x00022017),
  MRZ_INCORRECT(0x00022018),
  BIOMETRICS_FORMAT_OWNER_MISSING(0x90010000),
  BIOMETRICS_FORMAT_OWNER_INCORRECT(0x90020000),
  BIOMETRICS_FORMAT_TYPE_MISSING(0x90030000),
  BIOMETRICS_FORMAT_TYPE_INCORRECT(0x90040000),
  BIOMETRICS_TYPE_INCORRECT(0x90050000),
  BIOMETRICS_SUB_TYPE_MISSING(0x90060000),
  BIOMETRICS_SUB_TYPE_INCORRECT(0x90070000),
  BIOMETRICS_BDB_IMAGE_MISSING(0x90080000),
  BIOMETRICS_BDB_FORMAT_ID_INCORRECT(0x90090000),
  BIOMETRICS_BDB_VERSION_INCORRECT(0x900A0000),
  BIOMETRICS_BDB_DATA_LENGTH_INCORRECT(0x900B0000),
  BIOMETRICS_BDB_DATA_GENDER(0x90100000),
  BIOMETRICS_BDB_DATA_EYE_COLOR(0x90110000),
  BIOMETRICS_BDB_DATA_HAIR_COLOR(0x90120000),
  BIOMETRICS_BDB_DATA_POSE_ANGLE_YAW(0x90130000),
  BIOMETRICS_BDB_DATA_POSE_ANGLE_PITCH(0x90140000),
  BIOMETRICS_BDB_DATA_POSE_ANGLE_ROLL(0x90150000),
  BIOMETRICS_BDB_DATA_POSE_ANGLE_U_YAW(0x90160000),
  BIOMETRICS_BDB_DATA_POSE_ANGLE_U_PITCH(0x90170000),
  BIOMETRICS_BDB_DATA_POSE_ANGLE_U_ROLL(0x90180000),
  BIOMETRICS_BDB_DATA_FACE_IMAGE_TYPE(0x90190000),
  BIOMETRICS_BDB_DATA_IMAGE_DATA_TYPE(0x901A0000),
  SI_PACE_INFO_UNSUPPORTED_STD_PARAMETERS(0x91000000),
  SI_PACE_INFO_DEPRECATED_VERSION(0x91000001),
  SI_PACE_DOMAIN_PARAMS_USING_STD_REF(0x91000002),
  SI_PACE_DOMAIN_PARAMS_UNSUPPORTED_ALGORITHM(0x91000003),
  SI_CA_INFO_INCORRECT_VERSION(0x91000004),
  SI_CA_PUBLIC_KEY_UNSUPPORTED_ALGORITHM(0x91000005),
  SI_CA_DOMAIN_PARAMS_UNSUPPORTED_ALGORITHM(0x91000006),
  SI_TA_INFO_INCORRECT_VERSION(0x91000007),
  SI_TA_INFO_FILE_ID_FOR_VERSION2(0x91000008),
  SI_EID_SECURITY_UNSUPPORTED_DIGEST_ALGORITHM(0x91000009),
  SI_RI_INFO_INCORRECT_VERSION(0x9100000A),
  SI_RI_DOMAIN_PARAMS_UNSUPPORTED_ALGORITHM(0x9100000B),
  SI_AA_INFO_INCORRECT_VERSION(0x9100000C),
  SI_AA_INFO_UNSUPPORTED_ALGORITHM(0x9100000D),
  SI_AA_INFO_INCONSISTENT_ALGORITHM_REFERENCE(0x9100000E),
  SI_STORAGE_PACE_INFO_NOT_AVAILABLE(0x91000100),
  SI_STORAGE_PACE_INFO_NO_STD_PARAMETERS(0x91000101),
  SI_STORAGE_PACE_INFO_NO_MATCHING_DOMAIN_PARAMS(0x91000102),
  SI_STORAGE_CA_INFO_NOT_AVAILABLE(0x91000103),
  SI_STORAGE_CA_DOMAIN_PARAMS_NO_REQUIRED_OPTION(0x91000104),
  SI_STORAGE_CA_DOMAIN_PARAMS_NOT_AVAILABLE(0x91000105),
  SI_STORAGE_CA_ANONYMOUS_INFOS(0x91000106),
  SI_STORAGE_CA_INFO_NO_MATCHING_DOMAIN_PARAMS(0x91000107),
  SI_STORAGE_CA_INFO_NO_MATCHING_PUBLIC_KEY(0x91000108),
  SI_STORAGE_CA_INCORRECT_INFOS_QUANTITY(0x91000109),
  SI_STORAGE_TA_INFO_NOT_AVAILABLE(0x9100010A),
  SI_STORAGE_CARD_INFO_LOCATOR_MULTIPLE_ENTRIES(0x9100010B),
  SI_STORAGE_EID_SECURITY_INFO_MULTIPLE_ENTRIES(0x9100010C),
  SI_STORAGE_PRIVILEGED_TI_MULTIPLE_ENTRIES(0x9100010D),
  SI_STORAGE_PRIVILEGED_TI_INCORRECT_USAGE(0x9100010E),
  SI_STORAGE_RI_DOMAIN_PARAMS_MULTIPLE_ENTRIES(0x9100010F),
  SI_STORAGE_PACE_INFOS_NON_CONSISTANT(0x91000110),
  CV_CERTIFICATE_PROFILE_INCORRECT_VERSION(0x91000201),
  CV_CERTIFICATE_VALIDITY(0x91000202),
  CV_CERTIFICATE_NON_CV_CA_DOMAIN_PARAMETERS(0x91000203),
  CV_CERTIFICATE_PRIVATE_KEY_INCORRECT_VERSION(0x91000204),
  TA_PACE_STATIC_BINDING_USED(0x91000300),
  AUTH_ML_SIGNER_INFO_CERTIFICATE_VALIDITY(0x92000115),
  AUTH_ML_SIGNER_INFO_CERTIFICATE_ROOT_IS_NOT_TRUSTED(0x92000116),
  AUTH_ML_SIGNER_INFO_CERTIFICATE_CANT_FIND_CSCA(0x92000117),
  AUTH_ML_SIGNER_INFO_CERTIFICATE_REVOKED(0x92000118),
  AUTH_ML_SIGNER_INFO_CERTIFICATE_SIGNATURE_INVALID(0x92000119),
  NTF_LDS_ICAO_CERTIFICATE_CHAIN_COUNTRY_NON_MATCHING(0x90000250),
  NTF_LDS_ICAO_CERTIFICATE_VISUAL_MRZ_COUNTRY_NON_MATCHING(0x90000251),
  NTF_LDS_MRZ_COUNTRYCODE_VISUALMRZ_NON_MATCHING(0x00022019),
  NTF_LDS_ICAO_CERTIFICATE_MRZ_COUNTRY_NON_MATCHING(0x90000252);

  const LDSParsingNotificationCodes(this.value);
  final int value;

  Future<String> getTranslation() async {
    return await _bridge
        .invokeMethod("getTranslation", [runtimeType.toString(), value]);
  }

  static LDSParsingNotificationCodes? getByValue(int? i) {
    if (i == null) return null;
    try {
      return LDSParsingNotificationCodes.values.firstWhere((x) => x.value == i);
    } catch (_) {
      return LDSParsingNotificationCodes.UNKNOWN;
    }
  }
}
